function report_contrato_inmobiliaria(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportInmobiliariaWidget = reporting.Base.extend({
        template: 'ReportInmobiliariaWidget',
        rowsData :[],
        content :[],

        events:{
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-date' : 'ShowDateRange',
            'change #current-next-date' : 'ShowDateRange',
            'click .print-report':'clickOnAction',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new model.eiru_reports.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },


        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            var next_date = self.$el.find('#current-next-date').val();
            if (date && date != 9999999){
              self.$el.find('#current-next-date').val(9999999);
              self.$el.find('#current-next-date').prop('disabled','disabled');
              self.$el.find('.datepicker').css('display','none');
              if(date == 'range'){
                  self.$el.find('.datepicker').css('display','block');
              }
              if(date != 'range'){
                  self.$el.find('.datepicker').css('display','none');
              }
            }else {
              self.$el.find('#current-next-date').prop('disabled',false);
            }
            if (next_date && next_date != 9999999){
              self.$el.find('#current-date').val(9999999);
              self.$el.find('#current-date').prop('disabled','disabled');
              self.$el.find('.datepicker').css('display','none');
              if(next_date == 'range'){
                  self.$el.find('.datepicker').css('display','block');
              }
              if(next_date != 'range'){
                  self.$el.find('.datepicker').css('display','none');
              }
            }else{
              self.$el.find('#current-date').prop('disabled',false);
            }

        },

        fetchInitial: function () {
            var self = this;
            self.fetchInitialSQL().then(function (InitialSQL) {
                return InitialSQL;
            }).then(function(InitialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = InitialSQL.companies;
                self.CompanyLogo = InitialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = InitialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                    RES PARTNER
                =================================
                */
                self.ResPartner = InitialSQL.partner;
                if(self.ResPartner.length > 1){
                    self.$el.find('#current-customer').append('<option value="9999999">Todas los clientes</option>');
                    _.each(self.ResPartner,function(item){
                        self.$el.find('#current-customer').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.customer').css('display','none');
                }

            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.ResPartner = DataSQL.partners;
                self.Contracts = DataSQL.contracts;

                return self.BuildTable();
            });
        },

        fetchInitialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data-inmobiliaria');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-contracts-inmobiliaria');
            return data;
        },


        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        get_contracts:function(number) {
            var self = this;
            var content = self.Contracts;
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var next_date = self.$el.find('#current-next-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            if(state && state != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.state == state;
                }));
            }

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === lastMonth;
                    }));
                }
            }

            if(next_date && next_date != 9999999){
                if(next_date == 'range'){
                    if(desde){
                        next_date = desde.split('/');
                        next_date = (next_date[2]+"-"+next_date[1]+"-"+next_date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.recurring_next_date).format('YYYY-MM-DD') >= next_date;
                        }));
                    }
                    if(hasta){
                        next_date = hasta.split('/');
                        next_date = (next_date[2]+"-"+next_date[1]+"-"+next_date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.recurring_next_date).format('YYYY-MM-DD') <= next_date;
                        }));
                    }
                }
                if(next_date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.recurring_next_date).format('YYYY-MM-DD') === today;
                    }));
                }
                if(next_date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.recurring_next_date).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(next_date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.recurring_next_date).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(next_date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.recurring_next_date).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            return content;
        },


        BuildTable: function(){
            var self = this;
            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;

            var contracts = self.get_contracts();

            _.each(contracts, function(item){
              if(item.recurring_rule_type == "daily"){ var frecuencia = "Diario"};
              if(item.recurring_rule_type == "weekly"){ var frecuencia = "Semanal"};
              if(item.recurring_rule_type == "monthly"){ var frecuencia = "Mensual"};
              if(item.recurring_rule_type == "yearly"){ var frecuencia = "Anual"};

              if(item.state == "open"){ var estado = "En curso"};
              if(item.state == "pending"){ var estado = "A renovar"};
              if(item.state == "close"){ var estado = "Cerrado"};
              if(item.state == "cancelled"){ var estado = "Cancelado"};

              data.push({
                  id:item.id,
                  name: item.name,
                  code: item.code,
                  partner_name: item.partner_name,
                  cuota_total: self.valorNull(item.cuota_total),
                  nro_cuotas: self.valorNull(item.nro_cuotas),
                  recurring_next_date: item.recurring_next_date != null ? moment(item.recurring_next_date).format('DD/MM/YYYY'): "",
                  recurring_rule_type: frecuencia,
                  date: item.date != null ? moment(item.date).format('DD/MM/YYYY') : "",
                  state: estado,


                  /*
                  ===========================
                      NO FORMAT
                  ===========================
                  */
                  // date_no_format:moment(utc._d).format('YYYY-MM-DD'),
                  // total_no_format:item.amount,
                  // sale_amount_no_format: suma,
                  /*
                  ===========================
                      FOOTER
                  ===========================
                  */
                  decimal_places:CurrencyBase.decimal_places,
                  thousands_separator:CurrencyBase.thousands_separator,
                  decimal_separator:CurrencyBase.decimal_separator,
              });

            });


            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.ResCompany,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = CompanyLogo[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.CompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }

            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            row.push({
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Contratos';
                var pdf_type = 'l';
                var pdf_name = 'contratos_';
                var pdf_columnStyles = {
                    code:{columnWidth:18, halign:'left'},
                    name:{halign:'left'},
                    partner_name:{halign:'left'},
                    nro_cuotas:{columnWidth:15, align:'center'},
                    cuota_total:{columnWidth:15, align:'center'},
                    recurring_next_date:{columnWidth: 18, halign:'left'},
                    recurring_rule_type:{columnWidth: 20, halign:'left'},
                    date:{columnWidth: 18, halign:'left'},
                    state:{columnWidth: 19, halign:'left'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new model.eiru_reports.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var state = self.$el.find('#current-state').val();
            var next_date = self.$el.find('#current-next-date').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var filter = [];

            if(company && company != 9999999){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                        return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value:  ResStore[0].name,
                });
            }

            if(state && state != 9999999){
                filter.push({
                    title: 'Estado',
                    value: $('#current-state option:selected').text(),
                });
            }


            if(next_date && next_date != 9999999){
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });

                if(next_date == 'range'){
                    filter.push({
                        title: 'Fecha',
                        value:  desde +' al '+hasta,
                    });
                }else {
                    var fecha;
                    if(next_date == 'today'){
                        fecha = moment().format('DD/MM/YYYY');
                    }
                    if(next_date == 'yesterday'){
                        fecha = moment().add(-1,'days').format('DD/MM/YYYY');
                    }
                    if(next_date == 'currentMonth'){
                        fecha = moment().format('MMMM/YYYY');
                    }
                    if(next_date == 'lastMonth'){
                        fecha = moment().add(-1,'months').format('MMMM/YYYY');
                    }
                    filter.push({
                        title: 'Fecha Próx Factura',
                        value:  fecha,
                    });
                }
            }

            if(date && date != 9999999){
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });

                if(date == 'range'){
                    filter.push({
                        title: 'Fecha',
                        value:  desde +' al '+hasta,
                    });
                }else {
                    var fecha;
                    if(date == 'today'){
                        fecha = moment().format('DD/MM/YYYY');
                    }
                    if(date == 'yesterday'){
                        fecha = moment().add(-1,'days').format('DD/MM/YYYY');
                    }
                    if(date == 'currentMonth'){
                        fecha = moment().format('MMMM/YYYY');
                    }
                    if(date == 'lastMonth'){
                        fecha = moment().add(-1,'months').format('MMMM/YYYY');
                    }
                    filter.push({
                        title: 'Fecha Fin Contrato',
                        value:  fecha,
                    });
                }
            }
            return filter;
        },
    });
}
