function report_propiedades_inmobiliaria(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportPropiedadesInmobiliariaWidget = reporting.Base.extend({
        template: 'ReportPropiedadesInmobiliariaWidget',
        rowsData :[],
        content :[],

        events:{
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'click .print-report':'clickOnAction',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new model.eiru_reports.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },


        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },



        fetchInitial: function () {
            var self = this;
            self.fetchInitialSQL().then(function (InitialSQL) {
                return InitialSQL;
            }).then(function(InitialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = InitialSQL.companies;
                self.CompanyLogo = InitialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = InitialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                       supplier
                =================================
                */
                self.Supplier = InitialSQL.supplier;
                if(self.Supplier.length > 0){
                    self.$el.find('#current-supplier').append('<option value="9999999">Todas los propietarios</option>');
                    _.each(self.Supplier,function(item){
                        self.$el.find('#current-supplier').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.supplier').css('display','none');
                }

                /*
                =================================
                       Estado
                =================================
                */
                self.State = InitialSQL.property_state;
                if(self.State.length > 0){
                    self.$el.find('#current-state').append('<option value="9999999">Todas los estados</option>');
                    _.each(self.State,function(item){
                        self.$el.find('#current-state').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.state').css('display','none');
                }

            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.Template = DataSQL.template;
                self.Supplier = DataSQL.supplier;
                return self.BuildTable();
            });
        },

        fetchInitialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data-inmobiliaria');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-propiedades-inmobiliaria');
            return data;
        },


        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getProductTemplate:function() {
            var self = this;
            var content = self.Template;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var supplier = self.$el.find('#current-supplier').val();
            var state = self.$el.find('#current-state').val();

            if((store && store != 9999999)||(company && company != 9999999)){
                var store_ids = _.flatten(_.map(self.ResStore, function (item) {
                    return item.id;
                }));
                var company_ids = _.flatten(_.map(self.ResCompany, function (item) {
                    return item.id;
                }));
                content = _.flatten(_.filter(content,function (item) {
                    return _.contains(store_ids, item.store_id) && _.contains(company_ids, item.company_id);
                }));
            }

            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }

            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }

            if(supplier && supplier != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.propietario_id == supplier;
                }));
            }

            if(state && state != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.estado_id == state;
                }));
            }
            return content;
        },


        BuildTable: function(){
            var self = this;
            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;

            var template = self.getProductTemplate();

            _.each(template, function(item){
              data.push({
                  id:item.id,
                  propietario_name: self.valorNull(item.propietario_name),
                  name: item.name,
                  tamanho:self.valorNull(item.tamanho),
                  direccion: self.valorNull(item.direccion),
                  precio:item.precio,
                  estado_name:self.valorNull(item.estado_name),
                  descripcion:self.valorNull(item.descripcion),

                  /*
                  ===========================
                      FOOTER
                  ===========================
                  */
                  decimal_places:CurrencyBase.decimal_places,
                  thousands_separator:CurrencyBase.thousands_separator,
                  decimal_separator:CurrencyBase.decimal_separator,
              });

            });


            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.ResCompany,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = CompanyLogo[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.CompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }

            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            row.push({
            });


            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Propiedades';
                var pdf_type = '';
                var pdf_name = 'propiedades_';
                var pdf_columnStyles = {
                    propietario_name:{columnWidth:25, halign:'left'},
                    name:{columnWidth: 20, halign:'left'},
                    tamanho:{columnWidth: 16,halign:'left'},
                    direccion:{halign:'left'},
                    precio:{columnWidth: 25, halign:'right'},
                    estado_name:{columnWidth: 18, halign:'left'},
                    descripcion:{columnWidth: 30, halign:'left'},

                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new model.eiru_reports.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var supplier = self.$el.find('#current-supplier').val();
            var state = self.$el.find('#current-state').val();

            var filter = [];
            if(company && company != 9999999){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                        return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value:  ResStore[0].name,
                });
            }

            if(supplier && supplier != 9999999){
                var Supplier = _.filter(self.Supplier, function(item){
                    return item.id == supplier;
                });
                filter.push({
                    title:'Cliente',
                    value: Supplier[0].name,
                });
            }

            if(state && state != 9999999){
                var State = _.filter(self.State, function(item){
                    return item.id == state;
                });
                filter.push({
                    title:'Estado',
                    value: State[0].name,
                });
            }
            return filter;
        },
    });
}
